/**
 * Program RobominNet.java
 * 
 * Date         Version    Author         Comment
 * 2008/03/14   1.0.0      T.Kawashima    First.
 * 
 */

package robomin.robot;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.logging.Level;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;

import robomin.util.RobominLogger;
import robomin.util.RobominDef;
import robomin.util.RobominInfo;

/**
 * lbg^T[ƒʐMsNX
 * @author T.Kawashima
 * @version 1.0.0
 */
public class NetTansorCmd {
	private RobominInfo info;
	private RobominLogger logger;
	
	/**
	 * RXgN^
	 * @param info ʏۑNX
	 */
	public NetTansorCmd(RobominInfo info) {
		this.info = info;
		logger = this.info.getRobominLogger();
	}
	
	/**
	 * lbg^T[Ƀf[^𑗐M
	 * @param rInfo \Pbg
	 * @param data Mf[^
	 * @return ꍇ0 sꍇ-1
	 */
	public int sendData(RobotInfo rInfo, String data) {
		try {
			rInfo.getBufferedWriter().write(data);
			rInfo.getBufferedWriter().flush();
		}
		catch (IOException e) {
			logger.log(Level.SEVERE, "G[", e);
			return RobominDef.FAIL;
		}
		
		logger.log(Level.CONFIG, "SendCmd: " + data);

		return RobominDef.SUCCESS;
	}
	
	/**
	 * OiރR}h𑗐Mx[X (rightSensorAfrontSensorAleftSensor͏ȗ)
	 * @param rInfo
	 * @param cmd ft, bk
	 * @param power [^[p[ 1`31
	 * @param distance  1`250
	 * @param rSensor ΕZT[ 0`5 0͖
	 * @param fSensor ΕZT[ 0`5 0͖
	 * @param lSensor ΕZT[ 0`5 0͖
	 * @return ꍇ0 sꍇ-1 ls̏ꍇ-2
	 */
	private int sendCmdFBBase(RobotInfo rInfo, String cmd, int power, int distance, int rSensor, int fSensor, int lSensor) {
		String data = "";

		// p[l`FbN
		if (power < RobominDef.NTPOWER_MIN || power > RobominDef.NTPOWER_MAX) return RobominDef.FAIL_SIZE;

		// l`FbN
		if (distance < RobominDef.NTDISTANCE_MIN || distance > RobominDef.NTDISTANCE_MAX) return RobominDef.FAIL_SIZE;

		// R}h쐬
		data = cmd + RobominDef.NTCMD_DELIMITER +
			RobominDef.NTCMD_GREA + power + RobominDef.NTCMD_LESS + RobominDef.NTCMD_DELIMITER +
			RobominDef.NTCMD_GREA + distance + RobominDef.NTCMD_LESS;

		// ΕZT[̒lw肪ꍇ	
		if (rSensor >= RobominDef.NTSENSOR_MIN && rSensor <= RobominDef.NTSENSOR_MAX) {
			if(checkAndAddIRSensorValue(data, rSensor, fSensor, lSensor) < 0) return RobominDef.FAIL_SIZE;
		}

		data += RobominDef.NTCMD_CR;

		return sendData(rInfo, data);
	}	
	
	/**
	 * ΕZT[l`FbNR}hɕt
	 * @param data MR}h
	 * @param rSensor ΕZT[ 0`5 0͖
	 * @param fSensor ΕZT[ 0`5 0͖
	 * @param lSensor ΕZT[ 0`5 0͖
	 * @return ꍇ0 sꍇ-1 ls̏ꍇ-2
	 * @throws NumberFormatException
	 */
	private int checkAndAddIRSensorValue(String data, int rSensor, int fSensor, int lSensor) {
		// EZT[`FbN
		if (rSensor < RobominDef.NTSENSOR_MIN || rSensor > RobominDef.NTSENSOR_MAX) return RobominDef.FAIL_SIZE;
		
		// OZT[`FbN
		if (fSensor < RobominDef.NTSENSOR_MIN || fSensor > RobominDef.NTSENSOR_MAX) return RobominDef.FAIL_SIZE;
		
		// ZT[`FbN
		if (lSensor < RobominDef.NTSENSOR_MIN || lSensor > RobominDef.NTSENSOR_MAX) return RobominDef.FAIL_SIZE;
		
		// R}h쐬
		data += RobominDef.NTCMD_DELIMITER +
		RobominDef.NTCMD_GREA + rSensor + RobominDef.NTCMD_LESS + RobominDef.NTCMD_DELIMITER +
		RobominDef.NTCMD_GREA + fSensor + RobominDef.NTCMD_LESS + RobominDef.NTCMD_DELIMITER +
		RobominDef.NTCMD_GREA + lSensor + RobominDef.NTCMD_LESS;
		
		return RobominDef.SUCCESS;
	}
	
	/**
	 * OiR}h𑗐M (rightSensorAfrontSensorAleftSensor͏ȗ)
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param distance  1`250
	 * @param rightSensor ΕZT[ 0`5 0͖
	 * @param frontSensor ΕZT[ 0`5 0͖
	 * @param leftSensor ΕZT[ 0`5 0͖
	 * @return ꍇ0 sꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdForward(RobotInfo rInfo, int power, int distance, int rightSensor, int frontSensor, int leftSensor) {
		return sendCmdFBBase(rInfo, RobominDef.NTCMD_FORWARD, power, distance, rightSensor, frontSensor, leftSensor);
	}
	
	/**
	 * ރR}h𑗐M (rightSensorAfrontSensorAleftSensor͏ȗ)
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param distance  1`250
	 * @param rightSensor ΕZT[ 0`5 0͖
	 * @param frontSensor ΕZT[ 0`5 0͖
	 * @param leftSensor ΕZT[ 0`5 0͖
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdBackward(RobotInfo rInfo, int power, int distance, int rightSensor, int frontSensor, int leftSensor) {
		return sendCmdFBBase(rInfo, RobominDef.NTCMD_BACKWARD, power, distance, rightSensor, frontSensor, leftSensor);
	}
	
	/**
	 * ]R}h𑗐Mx[X (rightSensorAfrontSensorAleftSensor͏ȗ)
	 * @param rInfo \Pbg
	 * @param cmd R}h rt,lt,fr,fl
	 * @param power [^[p[ 1`31
	 * @param angle px 1`360
	 * @param rSensor ΕZT[ 0`5 0͖
	 * @param fSensor ΕZT[ 0`5 0͖
	 * @param lSensor ΕZT[ 0`5 0͖
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	private int sendCmdRotateBase(RobotInfo rInfo, String cmd, int power, int angle, int rSensor, int fSensor, int lSensor) {
		String data = "";
		
		// p[l`FbN
		if (power < RobominDef.NTPOWER_MIN || power > RobominDef.NTPOWER_MAX) return RobominDef.FAIL_SIZE;
		
		// px`FbN
		if (angle < RobominDef.NTANGLE_MIN || angle > RobominDef.NTANGLE_MAX) return RobominDef.FAIL_SIZE;
	
		// R}h쐬
		data = cmd + RobominDef.NTCMD_DELIMITER +
			RobominDef.NTCMD_GREA + power + RobominDef.NTCMD_LESS + RobominDef.NTCMD_DELIMITER +
			RobominDef.NTCMD_GREA + angle + RobominDef.NTCMD_LESS;
			
		// ΕZT[̒lw肪ꍇ	
		if (rSensor >= RobominDef.NTSENSOR_MIN && rSensor <= RobominDef.NTSENSOR_MAX) {
			if(checkAndAddIRSensorValue(data, rSensor, fSensor, lSensor) < 0) return RobominDef.FAIL_SIZE;
		}
		
		data += RobominDef.NTCMD_CR;
		
		return sendData(rInfo, data);
	}
	
	/**
	 * E]R}h𑗐M
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param angle px 1`360
	 * @param rSensor ΕZT[ 0`5 0͖
	 * @param fSensor ΕZT[ 0`5 0͖
	 * @param lSensor ΕZT[ 0`5 0͖
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdRRotate(RobotInfo rInfo, int power, int angle, int rSensor, int fSensor, int lSensor) {
		return sendCmdRotateBase(rInfo, RobominDef.NTCMD_RROTATE, power, angle, rSensor, fSensor, lSensor);
	}
	
	/**
	 * ]R}h𑗐M
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param angle px 1`360
	 * @param rSensor ΕZT[ 0`5 0͖
	 * @param fSensor ΕZT[ 0`5 0͖
	 * @param lSensor ΕZT[ 0`5 0͖
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdLRotate(RobotInfo rInfo, int power, int angle, int rSensor, int fSensor, int lSensor) {
		return sendCmdRotateBase(rInfo, RobominDef.NTCMD_LROTATE, power, angle, rSensor, fSensor, lSensor);
	}
	
	/**
	 * EOiJ[uR}h𑗐M
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param angle px 1`360
	 * @param rSensor ΕZT[ 0`5 0͖
	 * @param fSensor ΕZT[ 0`5 0͖
	 * @param lSensor ΕZT[ 0`5 0͖
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdRFCurve(RobotInfo rInfo, int power, int angle, int rSensor, int fSensor, int lSensor) {
		return sendCmdRotateBase(rInfo, RobominDef.NTCMD_RFORWARD, power, angle, rSensor, fSensor, lSensor);
	}
	
	/**
	 * OiJ[uR}h𑗐M
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param angle px 1`360
	 * @param rSensor ΕZT[ 0`5 0͖
	 * @param fSensor ΕZT[ 0`5 0͖
	 * @param lSensor ΕZT[ 0`5 0͖
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdLFCurve(RobotInfo rInfo, int power, int angle, int rSensor, int fSensor, int lSensor) {
		return sendCmdRotateBase(rInfo, RobominDef.NTCMD_LFORWARD, power, angle, rSensor, fSensor, lSensor);
	}
	
	/**
	 * EރJ[uR}h𑗐M
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param angle px 1`360
	 * @param rSensor ΕZT[ 0`5 0͖
	 * @param fSensor ΕZT[ 0`5 0͖
	 * @param lSensor ΕZT[ 0`5 0͖
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdRBCurve(RobotInfo rInfo, int power, int angle, int rSensor, int fSensor, int lSensor) {
		return sendCmdRotateBase(rInfo, RobominDef.NTCMD_RBACKWARD, power, angle, rSensor, fSensor, lSensor);
	}
	
	/**
	 * ރJ[uR}h𑗐M
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param angle px 1`360
	 * @param rSensor ΕZT[ 0`5 0͖
	 * @param fSensor ΕZT[ 0`5 0͖
	 * @param lSensor ΕZT[ 0`5 0͖
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdLBCurve(RobotInfo rInfo, int power, int angle, int rSensor, int fSensor, int lSensor) {
		return sendCmdRotateBase(rInfo, RobominDef.NTCMD_LBACKWARD, power, angle, rSensor, fSensor, lSensor);
	}
	
	/**
	 * ~R}h𑗐M
	 * @param rInfo \Pbg
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdStop(RobotInfo rInfo) {
		return sendData(rInfo, RobominDef.NTCMD_STOP + RobominDef.NTCMD_GREA + RobominDef.NTCMD_CR + RobominDef.NTCMD_LESS);
	}
	
	/**
	 * R}h𑗐Mx[X
	 * @param rInfo \Pbg
	 * @param cmd explore, follow, watch
	 * @param power [^[p[ 1`31
	 * @param sensitivity ZT[x 0`5
	 * @param time Ǝ 1`250
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	private int sendCmdAutoBase(RobotInfo rInfo, String cmd, int power, int sensitivity, int time) {
		String data = "";

		// p[l`FbN
		if (power < RobominDef.NTPOWER_MIN || power > RobominDef.NTPOWER_MAX) return RobominDef.FAIL_SIZE;
		
		// ZT[x`FbN
		if (sensitivity < RobominDef.NTSENS_MIN || sensitivity > RobominDef.NTSENS_MAX) return RobominDef.FAIL_SIZE;
		
		// ƎԂ`FbN
		if (time < RobominDef.NTTIME_MIN || time > RobominDef.NTTIME_MAX) return RobominDef.FAIL_SIZE;
	
		// R}h쐬
		data = cmd + RobominDef.NTCMD_DELIMITER +
			RobominDef.NTCMD_GREA + power + RobominDef.NTCMD_LESS + RobominDef.NTCMD_DELIMITER +
			RobominDef.NTCMD_GREA + sensitivity + RobominDef.NTCMD_LESS + RobominDef.NTCMD_DELIMITER +
			RobominDef.NTCMD_GREA + time + RobominDef.NTCMD_LESS+ RobominDef.NTCMD_CR;
	
		return sendData(rInfo, data);
	}
	
	/**
	 * TR}h𑗐M
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param sensitivity ZT[x 0`5
	 * @param time Ǝ 1`250
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdExplore(RobotInfo rInfo, int power, int sensitivity, int time) {
		return sendCmdAutoBase(rInfo, RobominDef.NTCMD_EXPLORE, power, sensitivity, time);
	}
	
	/**
	 * Ǐ]R}h𑗐M
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param sensitivity ZT[x 0`5
	 * @param time Ǝ 1`250
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdFollow(RobotInfo rInfo, int power, int sensitivity, int time) {
		return sendCmdAutoBase(rInfo, RobominDef.NTCMD_FOLLOW, power, sensitivity, time);
	}
	
	/**
	 * ڃR}h𑗐M
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param sensitivity ZT[x 0`5
	 * @param time Ǝ 1`250
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdWatch(RobotInfo rInfo, int power, int sensitivity, int time) {
		return sendCmdAutoBase(rInfo, RobominDef.NTCMD_WATCH, power, sensitivity, time);
	}
	
	/**
	 * ֘AR}h𑗐Mx[X
	 * @param rInfo \Pbg
	 * @param cmd bright, dark
	 * @param power [^[p[ 1`31
	 * @param time Ǝ 1`250
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	private int sendCmdLightBase(RobotInfo rInfo, String cmd, int power, int time) {
		String data = "";
		
		// p[l`FbN
		if (power < RobominDef.NTPOWER_MIN || power > RobominDef.NTPOWER_MAX) return RobominDef.FAIL_SIZE;

		// ƎԂ`FbN
		if (time < RobominDef.NTTIME_MIN || time > RobominDef.NTTIME_MAX) return RobominDef.FAIL_SIZE;
	
		// R}h쐬
		data = cmd + RobominDef.NTCMD_DELIMITER +
			RobominDef.NTCMD_GREA + power + RobominDef.NTCMD_LESS + RobominDef.NTCMD_DELIMITER +
			RobominDef.NTCMD_GREA + time + RobominDef.NTCMD_LESS+ RobominDef.NTCMD_CR;
	
		return sendData(rInfo, data);
	}
	
	/**
	 * R}h𑗐M
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param time Ǝ 1`250
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdBright(RobotInfo rInfo, int power, int time) {
		return sendCmdLightBase(rInfo, RobominDef.NTCMD_BRIGHT, power, time);
	}
	
	/**
	 * tR}h𑗐M
	 * @param rInfo \Pbg
	 * @param power [^[p[ 1`31
	 * @param time Ǝ 1`250
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdDark(RobotInfo rInfo, int power, int time) {
		return sendCmdLightBase(rInfo, RobominDef.NTCMD_DARK, power, time);
	}
	
	/**
	 * [^[R}h𑗐M
	 * @param rInfo \Pbg
	 * @param rMotor [^[p[ -31`31
	 * @param lMotor [^[p[ -31`31
	 * @return ꍇ0 Msꍇ-1 ls̏ꍇ-2
	 */
	public int sendCmdMM(RobotInfo rInfo, int rMotor, int lMotor) {
		String data = "";

		// E[^[l`FbN
		if (rMotor < RobominDef.NTMOTORP_MIN || rMotor > RobominDef.NTMOTORP_MAX) return RobominDef.FAIL_SIZE;

		// [^[`FbN
		if (lMotor < RobominDef.NTMOTORP_MIN || lMotor > RobominDef.NTMOTORP_MAX) return RobominDef.FAIL_SIZE;
	
		// R}h쐬
		data = RobominDef.NTCMD_MM + RobominDef.NTCMD_DELIMITER +
			RobominDef.NTCMD_GREA + rMotor + RobominDef.NTCMD_LESS + RobominDef.NTCMD_DELIMITER +
			RobominDef.NTCMD_GREA + lMotor + RobominDef.NTCMD_LESS+ RobominDef.NTCMD_CR;
	
		return sendData(rInfo, data);
	}
	
	/**
	 * lbg^T[̃J摜擾
	 * @param address lbg^T[̃AhX
	 * @return 擾J摜(BMP)
	 * @throws MalformedURLException URLw肳ꂽꍇ
	 */
	public Image getTansorCameraImage(String address) throws MalformedURLException {
		String cameraUrl = RobominDef.NTCAM_PREFIX + address + RobominDef.NTCAM_SUFFIX;
		return ImageDescriptor.createFromURL(new URL(cameraUrl)).createImage();
	}
}
