/**
 * Program RobominProperties.java
 * 
 * Date         Version    Author         Comment
 * 2008/03/11   1.0.0      T.Kawashima    First.
 * 
 */

package robomin.util;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Properties;

/**
 * vpeBt@C̓o
 * @author T.Kawashima
 * @version 1.0.0
 */
public class RobominProperties {
	private Properties prop;
	
	/**
	 * RXgN^
	 * @param fileName vpeBt@C
	 */
	public RobominProperties(String fileName) {
		prop = new Properties();
		
		try {
			prop.load(new FileInputStream(fileName));
		}
		catch (FileNotFoundException e) {
			// t@CȂꍇ͐VK쐬
			try {
				FileOutputStream output = new FileOutputStream(fileName);
				output.close();
			}
			catch (FileNotFoundException ee) {
				ee.printStackTrace();
			}
			catch (IOException ee) {
				ee.printStackTrace();
			}
		}
		catch (IOException e) {
			e.printStackTrace();
			
		}
	}
	
	/**
	 * vpeBt@Cɕۑ(bp[)
	 * @param out o͐
	 * @param comments t@CPsڂɏ܂Rg
	 * @throws IOException
	 */
	public void store(OutputStream out, String comments) throws IOException {
		prop.store(out, comments);
	}
	
	/**
	 * vpeBZbg(bp[)
	 * @param key ʎq
	 * @param value l
	 * @return setProperty̖߂l
	 */
	public Object setProperty(String key, String value) {
		return prop.setProperty(key, value);
	}
	
	/**
	 * vpeBQbg(bp[)
	 * @param key ʎq
	 * @return getProperty̖߂l
	 */
	public String getProperty(String key) {
		return prop.getProperty(key);
	}
	
	/**
	 * Integer^̃vpeBZbg
	 * @param key ʎq
	 * @param value l
	 * @return setProperty̖߂l
	 */
	public Object setPropertyInt(String key, int value) {
		return prop.setProperty(key, String.valueOf(value));
	}
	
	/**
	 * Integer^̃vpeBQbg
	 * @param key ʎq
	 * @return l
	 */
	public int getPropertyInt(String key) {
		int res = -1;
		
		String value = prop.getProperty(key);
		
		try {
			res = Integer.parseInt(value);
		}
		catch (NumberFormatException e) {
			System.out.println("No property: " + key);
		}
		
		return res;
	}
}
